package cn.net.cpzslibs.prot.handset.newProt;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.bean.res.ProtStatusResBean;
import cn.net.cpzslibs.prot.handset.bean.req.Prot20002ReqBean;
import cn.net.cpzslibs.prot.utils.StrUtils;


public class Prot20040ActivateWithPack extends ProtBase {
	/**
	 * 是否成功
	 */
	private short iResult;
	
	private final short iTaskCode20040 = 20040;
	private Gson gson;
	private ProtStatusResBean statusResBean;
	
	public Prot20040ActivateWithPack() {
//		this.sInspectorId = sInspectorId;
		gson = new Gson();
	}
	
	/*public String getJsonData() {
		return jsonData;
	}*/
	public ProtStatusResBean getResBean(){
		return this.statusResBean;
	}
	
	public void submitActivateInfo(SocketCreate create, Prot20002ReqBean reqBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), reqBean);
	}
	
	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, Prot20002ReqBean reqBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				//发送登录信息
				debugLog(iTaskCode20040, "开始提交激活信息");
				sendProt(dos, reqBean);
				/*List<String> allLabel = reqBean.getSingle();
				int eachCount = 2000;
				for(int i = 0* eachCount; i < allLabel.size();  i = i + eachCount){
					int end = (i+eachCount < allLabel.size())?(i+eachCount):allLabel.size();
					debugLog(iTaskCode20040, "当前数据：" + i);
					List<String> subList = allLabel.subList(i, end);
					Prot20002ReqBean cBean = new Prot20002ReqBean();
					cBean.setProduct_id(reqBean.getProduct_id());
					cBean.setProducer(reqBean.getProducer());
					cBean.setProduce_date(reqBean.getProduce_date());
					cBean.setProduce_batch(reqBean.getProduce_batch());
					cBean.setType(1);
					cBean.setSingle(subList);
					sendProt(dos, cBean);
					if (socket.isConnected()) {
						if (!socket.isInputShutdown()) {
							recLoginDis(dis);
						}
					}
				}*/
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLoginDis(dis);
			}
		}
	}
	
	/**
	 * 读取JSon数据
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode20040, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode20040, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			statusResBean = gson.fromJson(jsonData, ProtStatusResBean.class);
		}
		System.err.println("resBean: " + statusResBean.toString());
		
		recCheckCode(dis);
	}
	
	
	/**
	 * 发送JSon数据到服务器
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Prot20002ReqBean reqBean) throws IOException {
		String bodyContent = gson.toJson(reqBean).toString();
		debugLog(iTaskCode20040, "发送的数据格式：" + bodyContent);
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode20040, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
//		sendCheckCode(dos);
		sendCheckCoded(dos,bodyContent.getBytes("UTF-8"));
	}
	

}
